// generated from rosidl_generator_c/resource/idl__functions.h.em
// with input from plotjuggler_msgs:msg/Dictionary.idl
// generated code does not contain a copyright notice

#ifndef PLOTJUGGLER_MSGS__MSG__DETAIL__DICTIONARY__FUNCTIONS_H_
#define PLOTJUGGLER_MSGS__MSG__DETAIL__DICTIONARY__FUNCTIONS_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stdlib.h>

#include "rosidl_runtime_c/visibility_control.h"
#include "plotjuggler_msgs/msg/rosidl_generator_c__visibility_control.h"

#include "plotjuggler_msgs/msg/detail/dictionary__struct.h"

/// Initialize msg/Dictionary message.
/**
 * If the init function is called twice for the same message without
 * calling fini inbetween previously allocated memory will be leaked.
 * \param[in,out] msg The previously allocated message pointer.
 * Fields without a default value will not be initialized by this function.
 * You might want to call memset(msg, 0, sizeof(
 * plotjuggler_msgs__msg__Dictionary
 * )) before or use
 * plotjuggler_msgs__msg__Dictionary__create()
 * to allocate and initialize the message.
 * \return true if initialization was successful, otherwise false
 */
ROSIDL_GENERATOR_C_PUBLIC_plotjuggler_msgs
bool
plotjuggler_msgs__msg__Dictionary__init(plotjuggler_msgs__msg__Dictionary * msg);

/// Finalize msg/Dictionary message.
/**
 * \param[in,out] msg The allocated message pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_plotjuggler_msgs
void
plotjuggler_msgs__msg__Dictionary__fini(plotjuggler_msgs__msg__Dictionary * msg);

/// Create msg/Dictionary message.
/**
 * It allocates the memory for the message, sets the memory to zero, and
 * calls
 * plotjuggler_msgs__msg__Dictionary__init().
 * \return The pointer to the initialized message if successful,
 * otherwise NULL
 */
ROSIDL_GENERATOR_C_PUBLIC_plotjuggler_msgs
plotjuggler_msgs__msg__Dictionary *
plotjuggler_msgs__msg__Dictionary__create();

/// Destroy msg/Dictionary message.
/**
 * It calls
 * plotjuggler_msgs__msg__Dictionary__fini()
 * and frees the memory of the message.
 * \param[in,out] msg The allocated message pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_plotjuggler_msgs
void
plotjuggler_msgs__msg__Dictionary__destroy(plotjuggler_msgs__msg__Dictionary * msg);


/// Initialize array of msg/Dictionary messages.
/**
 * It allocates the memory for the number of elements and calls
 * plotjuggler_msgs__msg__Dictionary__init()
 * for each element of the array.
 * \param[in,out] array The allocated array pointer.
 * \param[in] size The size / capacity of the array.
 * \return true if initialization was successful, otherwise false
 * If the array pointer is valid and the size is zero it is guaranteed
 # to return true.
 */
ROSIDL_GENERATOR_C_PUBLIC_plotjuggler_msgs
bool
plotjuggler_msgs__msg__Dictionary__Sequence__init(plotjuggler_msgs__msg__Dictionary__Sequence * array, size_t size);

/// Finalize array of msg/Dictionary messages.
/**
 * It calls
 * plotjuggler_msgs__msg__Dictionary__fini()
 * for each element of the array and frees the memory for the number of
 * elements.
 * \param[in,out] array The initialized array pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_plotjuggler_msgs
void
plotjuggler_msgs__msg__Dictionary__Sequence__fini(plotjuggler_msgs__msg__Dictionary__Sequence * array);

/// Create array of msg/Dictionary messages.
/**
 * It allocates the memory for the array and calls
 * plotjuggler_msgs__msg__Dictionary__Sequence__init().
 * \param[in] size The size / capacity of the array.
 * \return The pointer to the initialized array if successful, otherwise NULL
 */
ROSIDL_GENERATOR_C_PUBLIC_plotjuggler_msgs
plotjuggler_msgs__msg__Dictionary__Sequence *
plotjuggler_msgs__msg__Dictionary__Sequence__create(size_t size);

/// Destroy array of msg/Dictionary messages.
/**
 * It calls
 * plotjuggler_msgs__msg__Dictionary__Sequence__fini()
 * on the array,
 * and frees the memory of the array.
 * \param[in,out] array The initialized array pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_plotjuggler_msgs
void
plotjuggler_msgs__msg__Dictionary__Sequence__destroy(plotjuggler_msgs__msg__Dictionary__Sequence * array);

#ifdef __cplusplus
}
#endif

#endif  // PLOTJUGGLER_MSGS__MSG__DETAIL__DICTIONARY__FUNCTIONS_H_
